import java.util.*;

relational aspect BinarySymmetricRelation(Object o1, Object o2) {

    after(Object x1, Object x2): call(* BinarySymmetricRelation.associate(..)) && args(x1,x2)
		&& !within(BinarySymmetricRelation) {
		associate(x2,x1);
    }
	
    after(Object x1, Object x2): call(* BinarySymmetricRelation.release(..)) && args(x1,x2)
		&& !within(BinarySymmetricRelation) {
    	release(x2,x1);
    }
    
    relational boolean around(o1,o2): execution(* BinarySymmetricRelation.associated(..)) && args(o1,o2) {
    	return true;
    }
    
    public static boolean associated(Object x1, Object x2) {
    	return false;
    }
}

class Tester {
	
    public static void main(String[] args) {
		BinarySymmetricRelation.associate("1","2");
		BinarySymmetricRelation.associate("3","4");
		BinarySymmetricRelation.release("4","3");
		if(!BinarySymmetricRelation.associated("2","1")) {
			throw new RuntimeException("Test failed. (1)");
		}
		System.out.println("Test passed (1)");
		if(BinarySymmetricRelation.associated("3","4")) {
			throw new RuntimeException("Test failed. (2)");
		}
		System.out.println("Test passed (2)");
	}

}
